<template>
  <v-app-bar v-if="loggedInUser" color="white" fixed :height="state.imgHeight + 20" class="uniform-elevation">
    <div class="d-flex" data-cy="HeaderLogos" style="cursor: pointer;" @click="navigateTo('/')">
      <v-img :height="state.imgHeight" :width="state.imgWidth" contain alt="Logo Ministère des Armées"
        src="/logo_ministere_armees.svg">
      </v-img>
      <v-divider vertical></v-divider>
      <v-tooltip bottom>
        <template #activator="{ props }">
          <v-img :height="state.imgHeight" :width="state.imgWidth" contain v-bind="props" alt="Logo Airvam"
            src="/airvam.svg">
          </v-img>
        </template>
        <span>Ce n'est pas de la SF, c'est Airvam ✈️</span>
      </v-tooltip>
    </div>
    <v-spacer></v-spacer>
    <v-tabs slider-color="primary">
      <v-tab to="/vols">
        <v-icon>flight</v-icon>
        Vols en prévision
      </v-tab>
      <v-tab to="/vols_archives">
        <v-icon>move_to_inbox</v-icon>
        Vols archivés
      </v-tab>
      <v-tab to="/documents">
        <v-icon>description</v-icon>
        Documents
      </v-tab>
      <v-tab v-has-role="['admin', 'god']" to="/administration">
        <v-icon>manage_accounts</v-icon>
        Administration
      </v-tab>
    </v-tabs>
    <v-spacer></v-spacer>
    <v-row density="compact" right class="flex-grow-0 flex-nowrap">
      <v-col>
        <v-menu offset-y>
          <template #activator="{ props }">
            <v-avatar color="primary" data-cy="LogoutUser" v-bind="props" size="40">
              <span class="white--text text-h6">
                {{ getInitials }}
              </span>
            </v-avatar>
          </template>
          <v-list>
            <v-list-item @click="logout()">
              <template #prepend><v-icon>logout</v-icon></template>
              <v-list-item-title>Déconnexion</v-list-item-title>
            </v-list-item>
          </v-list>
        </v-menu>
      </v-col>
      <v-col v-if="loggedInUser" align-self="center" style="white-space: nowrap;">
        <div class="font-weight-bold">{{ loggedInUser.firstName }} {{ loggedInUser.lastName }}
        </div>
        <div>{{ userRole }}</div>
      </v-col>
    </v-row>
  </v-app-bar>
</template>

<script setup lang="ts">
import { UserRole } from "~/dto/userRole.enum";

const state = reactive({
  imgWidth: 100,
  imgHeight: 60
});
const { loggedInUser } = storeToRefs(useStore());
const { signOut } = useAuth();

const userRole = computed(() => {
  if (loggedInUser.value) {
    const { role } = loggedInUser.value;
    return UserRole[role]
  }
})

const getInitials = computed(() => loggedInUser.value ? `${loggedInUser.value.firstName[0]}${loggedInUser.value.lastName[0]}` : '');

const logout = () => {
  signOut({ external: true });
}
</script>

<style lang="scss">
.v-toolbar__content {
    padding: 4px 16px;
}
</style>
